/**************************************************************************/
/* FILE NAME:                              COPYRIGHT (c) Freescale 2008   */
/* ISR_Routines_Dual.c                            All Rights Reserved     */
/*                                                                        */
/* DESCRIPTION:                                                           */
/* This is the interrupt controller configuration file.                   */
/*=========================================================================*/
/*                                                                        */
/*========================================================================*/
/* REV      AUTHOR        DATE        DESCRIPTION OF CHANGE               */
/* ---   -----------    ----------    ---------------------               */
/* 0.1    R. Moran       10/12/2008    Initial Version                    */
/**************************************************************************/
#include "..\header\mpc5675k-0200.h"

/*========================================================================*/
/*                      GLOBAL VARIABLES                                  */
/*========================================================================*/

/*========================================================================*/
/*                     INTERRUPT PRIORITIES                               */
/*========================================================================*/
/**************************************************************************/
/* FUNCTION     : Init_INTC_Priority - Core0                                      */
/* PURPOSE      : SET Interrupt Vector PRIORITIES HERE                    */
/**************************************************************************/
void Init_INTC_Priority(void) {

      // SSI0 IRQ
     INTC_0.PSR[0].B.PRI = 1;
     //INTC_0.PSR[0].B.PRC_SEL = 0;     // 0x0 - PRC0, 0x1 - both, 0x3 - PRC1
     
}
/**************************************************************************/
/* FUNCTION     : Init_INTC_Priority - Core1                                     */
/* PURPOSE      : SET Interrupt Vector PRIORITIES HERE                    */
/**************************************************************************/
void Init_INTC_Priority1(void) {

      // SSI0 IRQ
     INTC_1.PSR[0].B.PRI = 1;
//     INTC_1.PSR[0].B.PRC_SEL = 0;     // 0x0 - PRC0, 0x1 - both, 0x3 - PRC1
     
}

/*========================================================================*/
/*                   INTERRUPT SERVICE ROUTINES                           */
/*========================================================================*/

/**************************************************************************/
/* FUNCTION     : SSI0_ISR                                                */
/* PURPOSE      : Software Settable Interrupt 0 ISR                       */
/**************************************************************************/
void SSI0_ISR(void) {  
    
    // Clear Flag
    INTC_0.SSCIR[0].B.CLR = 0x1;
    
}
