// TGSCR fields
#define ETTM_Enable 0x0100

#define PRES_1 0x0000
#define PRES_2 0x0040
#define PRES_3 0x0080
#define PRES_4 0x00C0

#define MRSSM_I15FE 0     		// external sig falling edge
#define MRSSM_I15RE (1 << 1)	// external sig rising edge
#define MRSSM_I14FE (2 << 1)	// eTimer2 falling edge
#define MRSSM_I14RE (3 << 1)	// eTimer2 Rising edge
#define MRSSM_I13FE (4 << 1)	// eTimer1 falling edge
#define MRSSM_I13RE (5 << 1)	// eTimer1 Rising edge

#define MRSSM_I0FE (30 << 1)	// PWM reload falling edge
#define MRSSM_I0RE (31 << 1)	// PWM reload Rising edge 

#define TGSM_Sequential 0x0001

// CTU_x DMA source slot#
#define CTU_0_DMA_SLOT_NO			7	//CTU_0 for CTUCR.DMAE bits
#define CTU_0_FIFO_0_DMA_SLOT_NO	8	//FIFO0
#define CTU_0_FIFO_1_DMA_SLOT_NO	9	//FIFO1
#define CTU_0_FIFO_2_DMA_SLOT_NO	10	//FIFO2
#define CTU_0_FIFO_3_DMA_SLOT_NO	11	//FIFO3

#define CTU_1_DMA_SLOT_NO			28	//CTU_1 for CTUCR.DMAE bits
#define CTU_1_FIFO_0_DMA_SLOT_NO	29	//FIFO0
#define CTU_1_FIFO_1_DMA_SLOT_NO	30	//FIFO1
#define CTU_1_FIFO_2_DMA_SLOT_NO	31	//FIFO2
#define CTU_1_FIFO_3_DMA_SLOT_NO	32	//FIFO3

extern void ctu_0_init(void);
extern void ctu_1_init(void);
extern void ctu_0_ADC_commandlist_load(void);
extern void ctu_1_ADC_commandlist_load(void);